Attribute VB_Name = "Module1"
' Bestehende Region in beliebigem Winkel drehen
' Copyright  2011 by Zardoz

Option Explicit

Private Type RECT
  Left As Long
  Top As Long
  Right As Long
  Bottom As Long
End Type

Private Type XFORM
  eM11 As Single
  eM12 As Single
  eM21 As Single
  eM22 As Single
  eDx As Single
  eDy As Single
End Type

Public Declare Function DeleteObject Lib "gdi32" (ByVal hObject As Long) As Long
Private Declare Function ExtCreateRegion Lib "gdi32" (lpXform As XFORM, ByVal nCount As Long, ByRef lpRgnData As Any) As Long
Private Declare Function GetRegionData Lib "gdi32" (ByVal hRgn As Long, ByVal dwCount As Long, ByRef lpRgnData As Any) As Long
Private Declare Function GetRgnBox Lib "gdi32" (ByVal hRgn As Long, lpRect As RECT) As Long
Private Declare Function OffsetRgn Lib "gdi32" (ByVal hRgn As Long, ByVal x As Long, ByVal y As Long) As Long

Private Const Pi As Single = 3.141593

Public Sub RotateRegion(Region As Long, ByVal Winkel As Single)
  
  Dim Wnk As Single, N As Long, R1 As RECT
  Dim Matrix As XFORM
  Dim Buffer() As Byte
  
  ' Winkel in Bogenma umrechnen
  Wnk = (2 - Winkel / 180) * Pi
  ' Regionkoordinaten holen
  Call GetRgnBox(Region, R1)
  ' Matrix belegen
  With Matrix
    .eM11 = Cos(Wnk)
    .eM12 = Sin(Wnk)
    .eM21 = -.eM12
    .eM22 = .eM11
    .eDx = (R1.Left + R1.Right + 1) / 2
    .eDy = (R1.Top + R1.Bottom + 1) / 2
    Call OffsetRgn(Region, -.eDx, -.eDy)
  End With
  ' Anzahl Bytes abfragen
  N = GetRegionData(Region, 0, ByVal 0)
  ' Array anlegen
  ReDim Buffer(N - 1)
  ' Regiondaten in Array einlesen
  Call GetRegionData(Region, N, Buffer(0))
  ' Alte Region lschen
  Call DeleteObject(Region)
  ' Neue Region erstellen
  Region = ExtCreateRegion(Matrix, N, Buffer(0))
  
End Sub
